function out = LS_kx(kx, ky, x, y, x_s, y_s, k0, Er, sComp, bMsource)
global C MU0 EPSILON0
X = x-x_s;
Y = y-y_s;
rho = hypot(X, Y);
k = k0*sqrt(Er);
omega = k0*C;
eta = sqrt(MU0/EPSILON0./Er);
sigma_x = sign(X);
if ~bMsource
    switch lower(sComp)
        case 'ez'
            out = -omega/4*MU0*exp(-j*(kx.*abs(X)+ky.*abs(Y)))./ky/pi;
%            out = -omega/4*MU0*exp(-j*(kx.*(X)+ky.*abs(Y)))./ky/pi;
        case 'hx'
            out = -1/(4*pi).*exp(-j.*(kx.*abs(X)+ky.*abs(Y))).*sign(y);
        case 'hy'
            out = sigma_x./(4*pi).*exp(-j*(kx.*abs(X)+ky.*abs(Y))).*kx./ky;
        otherwise
            out = zeros(size(rho));
    end
else
    switch lower(sComp)
        case 'hz'
            out = -omega/4*MU0*exp(-j*(kx.*abs(X)+ky.*abs(Y)))./ky/pi./eta.^2;
        case 'ex'
            out = 1/(4*pi).*exp(-j*(kx.*abs(X)+ky.*abs(Y))).*sign(y);
        case 'ey'
            out = -sigma_x./(4*pi).*kx./ky.*exp(-j*(kx.*abs(X)+ky.*abs(Y)));
        otherwise
            out = zeros(size(rho));
    end
end