function out = LS_space(x, y, x_s, y_s, k0, Er, sComp, isMagneticSrc)
global C MU0 EPSILON0
X = x-x_s;
Y = y-y_s;
rho = hypot(X, Y);
rho(rho == 0) = eps;
isImproper = 0;
k = calc_kc(k0, 0, Er, isImproper);
omega = k0*C;
if ~isMagneticSrc
    switch lower(sComp)
        case 'ez'
            out = -omega/4*MU0*besselh(0,2,k.*rho);
        case 'hx'
            out = -Y./rho.*k/4/j.*besselh(1,2,k.*rho);
        case 'hy'
            out = X./rho.*k./4./j.*besselh(1,2,k.*rho);
        otherwise
            out = zeros(size(rho));
    end
else
   switch lower(sComp)
        case 'hz'
            out = -omega/4*EPSILON0*Er.*besselh(0,2,k.*rho);
        case 'ex'
            out = Y./rho.*k/4/j.*besselh(1,2,k.*rho);
        case 'ey'
            out = -X./rho.*k/4/j.*besselh(1,2,k.*rho);
        otherwise
            out = zeros(size(rho));
   end
end
if lower(sComp(1)) == 'd'
    out = out*Er;
end