% kc = calc_kc(k0, beta, Er, isImproper)
% if kc is real, it is positive for isImproper =0, and negative otherwise.
function kc = calc_kc(k0, beta, Er, isImproper)
[mK0, mBeta, mEr, mIsImproper] = rep_args(k0, beta, Er, isImproper);
kc = sqrt((mK0.^2.*mEr-mBeta.^2));

bImproper = imag(kc)>0;

kc(bImproper) = -kc(bImproper).*(1-2*mIsImproper(bImproper));
kc(~bImproper) = kc(~bImproper).*(1-2*mIsImproper(~bImproper));
