function [x, w] = gausshrhermite(n, vSigma, beta)
global RULES_DIR
strBeta = num2str(beta);
strN = num2str(n);
strFile = [RULES_DIR '\rule' strN '_' strBeta '.mat'];
if exist(strFile, 'file')
    load(strFile)
    bExist = 1;
else
    Mmax = n*500;
    eps0 = 1e-12;
    ab = r_hrhermite(n, Mmax, eps0, beta);
    xw = gauss(n, ab);
    bExist = 0;
end
if ~exist(RULES_DIR, 'dir')
    mkdir(RULES_DIR)
end
if ~bExist
    save(strFile, '-MAT', '-V6', 'xw');
end
x=xw(:,1);
w = xw(:,2).*exp(x.^2).*abs(x).^(-beta);
vSigma = vSigma(:);
x = x(:).';
w = w(:).';
x = vSigma*x;
w = vSigma*w;
