function field = integrand_vect(oPath, vX, vY, x_s, y_s, k0, Er_d, Er_u, sComp, bMSource, oIm)
mKx = oPath.kx;
mKy_inc = oPath.ky_d;
mKy_t = oPath.ky_u;
bv = oPath.bv;
vX = vX(bv);
vY = vY(bv);
nXY = length(vX);
nKx = size(mKx, 2);
mX = repmat(vX, 1, nKx);
mY = repmat(vY, 1, nKx);

bRef = vY<=0;
mRef = repmat(bRef, 1, nKx);
mIl = repmat(oIm.Il(bv), 1, nKx);
mImEr = repmat(oIm.Er(bv), 1, nKx);
mImX_s = repmat(oIm.x_s(bv), 1, nKx);
mImY_s = repmat(oIm.y_s(bv), 1, nKx);
phase_r = zeros(nXY, nKx);
phase_t = phase_r;
field = phase_r;
im = phase_r;

slow_amp = slowly_varying_no_beta(oPath, vX, vY, x_s, k0, Er_d, Er_u, sComp, bMSource);

phase_t(~mRef) = exp(-j*(mKx(~mRef).*abs(mX(~mRef)-x_s) + ...
    mKy_t(~mRef).*abs(mY(~mRef)) + mKy_inc(~mRef)*abs(y_s)));
field(~mRef) = slow_amp(~mRef).*phase_t(~mRef);

phase_r(mRef) = exp(-j*(mKx(mRef).*abs(mX(mRef)-x_s) + mKy_inc(mRef).*(abs(mY(mRef)) + abs(y_s))));
field(mRef) = slow_amp(mRef).*phase_r(mRef);

% subtract images
bFix = (mIl ~= 0);
if any(bFix)
    ky = zeros(size(mKx(bFix)));
    ky(bFix) = mKy_inc(bFix).*(mImEr(bFix) == Er_d) + mKy_t(bFix).*(mImEr(bFix) == Er_u);
    im(bFix) = -mIl(bFix).*LS_kx(mKx(bFix), ky(bFix), mX(bFix), mY(bFix), mImX_s(bFix), mImY_s(bFix), k0, mImEr(bFix), sComp, bMSource);
end

field = field+im;