function varargout = ndsdpGui(varargin)
% NDSDPGUI M-file for ndsdpGui.fig
%      NDSDPGUI, by itself, creates a new NDSDPGUI or raises the existing
%      singleton*.
%
%      H = NDSDPGUI returns the handle to a new NDSDPGUI or the handle to
%      the existing singleton*.
%
%      NDSDPGUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in NDSDPGUI.M with the given input arguments.
%
%      NDSDPGUI('Property','Value',...) creates a new NDSDPGUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before ndsdpGui_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to ndsdpGui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help ndsdpGui

% Last Modified by GUIDE v2.5 02-Jul-2009 14:27:20

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @ndsdpGui_OpeningFcn, ...
    'gui_OutputFcn',  @ndsdpGui_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before ndsdpGui is made visible.
function ndsdpGui_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to ndsdpGui (see VARARGIN)

% Choose default command line output for ndsdpGui
handles.output = hObject;

initialize_globals
handles.polarizationString = 'TM';
handles.x0 = 0;
handles.y0 = -1;
handles.maxX = 3;
handles.maxY = 3;
handles.minX = -3;
handles.minY = -3;
handles.zoomFact = 1.5;
axes(handles.axes)
axis([handles.minX, handles.maxX, handles.minY,handles.maxY])
line([handles.minX, handles.maxX], [0,0])
hold on
plot(handles.x0, handles.y0, 'ko')
plot(handles.x0, handles.y0, 'k.')
hold off
h = xlabel('$x/\lambda$');
set(h, 'interpreter', 'latex');
h = ylabel('$y/\lambda$');
set(h, 'interpreter', 'latex');
set(handles.animate, 'enable', 'off')
set(handles.calculating, 'visible', 'off');
set(handles.permLower, 'min', 1)
set(handles.permUpper, 'min', 1)
set(handles.permLower, 'max', 10)
set(handles.permUpper, 'max', 10)
lowerInitial = 1;
upperInitial = 3;
set(handles.permLower, 'value', lowerInitial)
set(handles.permUpper, 'value', upperInitial)
handles.permLowerVal = lowerInitial;
handles.permUpperVal = upperInitial;
set(handles.permLowerText, 'string', ['For y<0: ' num2str(lowerInitial)])
set(handles.permUpperText, 'string', ['For y>0: ' num2str(upperInitial)])
iptPointerManager(handles.figure1)
enterFcn = @(hFigure, currentPoint)...
             set(hFigure, 'Pointer', 'crosshair');
iptSetPointerBehavior(handles.axes, enterFcn);
% Update handles structure
guidata(hObject, handles);

% UIWAIT makes ndsdpGui wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = ndsdpGui_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in zoomIn.
function zoomIn_Callback(hObject, eventdata, handles)
% hObject    handle to zoomIn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.minX = handles.minX/handles.zoomFact;
handles.maxX = handles.maxX/handles.zoomFact;
handles.minY = handles.minY/handles.zoomFact;
handles.maxY = handles.maxY/handles.zoomFact;
calc_Callback(hObject, eventdata, handles);


% --- Executes on button press in zoomOut.
function zoomOut_Callback(hObject, eventdata, handles)
% hObject    handle to zoomOut (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.minX = handles.minX*handles.zoomFact;
handles.maxX = handles.maxX*handles.zoomFact;
handles.minY = handles.minY*handles.zoomFact;
handles.maxY = handles.maxY*handles.zoomFact;
calc_Callback(hObject, eventdata, handles);


% --- Executes on button press in animate.
function animate_Callback(hObject, eventdata, handles)
% hObject    handle to animate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.doAnimate = true;
guidata(hObject, handles);
update_axes(hObject, handles)
% --- Executes on slider movement.
function permLower_Callback(hObject, eventdata, handles)
% hObject    handle to permLower (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
set(handles.permLowerText, 'string', ['For y<0: ' num2str(get(hObject, 'value'),2)])
handles.permLowerVal = get(hObject, 'value');
set(handles.calc, 'enable', 'on')
guidata(hObject, handles)


% --- Executes during object creation, after setting all properties.
function permLower_CreateFcn(hObject, eventdata, handles)
% hObject    handle to permLower (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function permUpper_Callback(hObject, eventdata, handles)
% hObject    handle to permUpper (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
set(handles.permUpperText, 'string', ['For y>0: ' num2str(get(hObject, 'value'),2)])
handles.permUpperVal = get(hObject, 'value');
set(handles.calc, 'enable', 'on')
guidata(hObject, handles)

% --- Executes during object creation, after setting all properties.
function permUpper_CreateFcn(hObject, eventdata, handles)
% hObject    handle to permUpper (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on selection change in component.
function component_Callback(hObject, eventdata, handles)
% hObject    handle to component (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns component contents as cell array
%        contents{get(hObject,'Value')} returns selected item from component
calc_Callback(hObject, eventdata, handles);


% --- Executes during object creation, after setting all properties.
function component_CreateFcn(hObject, eventdata, handles)
% hObject    handle to component (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in complexPart.
function complexPart_Callback(hObject, eventdata, handles)
% hObject    handle to complexPart (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns complexPart contents as cell array
%        contents{get(hObject,'Value')} returns selected item from complexPart
if strcmpi(get(handles.calc, 'enable'), 'off')
    update_axes(hObject, handles);
end

% --- Executes during object creation, after setting all properties.
function complexPart_CreateFcn(hObject, eventdata, handles)
% hObject    handle to complexPart (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes when selected object is changed in sourceType.
function sourceType_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in sourceType
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)
switch get(eventdata.NewValue,'Tag') % Get Tag of selected object.
    case 'els'
        set(handles.els, 'value', 'max')
        set(handles.mls, 'value', 'min')
    case 'mls'
        set(handles.mls, 'value', 'max')
        set(handles.els, 'value', 'min')
end


% --- Executes on button press in els.
function els_Callback(hObject, eventdata, handles)
% hObject    handle to els (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of els
set(hObject, 'value', get(hObject,'max'))
if strcmpi(handles.polarizationString, 'TE') % state has changed
    comp = get(handles.component, 'value');
    switch comp % switch component to calculate
        case {1,2,3}
            newComp = comp+3;
        otherwise
            newComp = comp-3;
    end
    set(handles.component, 'value', newComp)
    handles.polarizationString='TM';
    set(handles.calc, 'enable', 'on')
end
guidata(hObject, handles);


% --- Executes on button press in mls.
function mls_Callback(hObject, eventdata, handles)
% hObject    handle to mls (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of mls
set(hObject, 'value', get(hObject,'max'))
if strcmpi(handles.polarizationString, 'TM') % state has changed
    comp = get(handles.component, 'value');
    switch comp % switch component to calculate
        case {1,2,3}
            newComp = comp+3;
        otherwise
            newComp = comp-3;
    end
    set(handles.component, 'value', newComp)
    handles.polarizationString='TE';
    set(handles.calc, 'enable', 'on')
end
guidata(hObject, handles);

% --- Executes on button press in calc.
function calc_Callback(hObject, eventdata, handles)
% hObject    handle to calc (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
Source.x = handles.x0;
Source.y = handles.y0;
lambda = 1;
Source.lambda = lambda;
Source.polarizationString = handles.polarizationString;
shortLambda = lambda/sqrt(max(handles.permLowerVal, handles.permUpperVal));
pointsPerShortLambda = 7;
nPointsX = (handles.maxX-handles.minX)/shortLambda*pointsPerShortLambda;
nPointsY = (handles.maxY-handles.minY)/shortLambda*pointsPerShortLambda;
nPointsX = max(nPointsX, 40);
nPointsY = max(nPointsY, 40);
x = linspace(handles.minX, handles.maxX, nPointsX);
y = linspace(handles.minY, handles.maxY, nPointsY);
[EvalAt.x, EvalAt.y] = meshgrid(x,y);
Options.useAdaptive = false; % Change the number of points adaptively.
Options.nPoints = 20; % Number of integration points (should be even).
componentStringArray = get(handles.component, 'string');
componentString = componentStringArray{get(handles.component, 'value')};
set(handles.calculating, 'visible', 'on');
prevPointer = get(handles.figure1, 'pointer');
set(handles.figure1, 'pointer', 'watch')
pause(0.01);
field = ndsdp(EvalAt, Source, handles.permLowerVal, handles.permUpperVal, componentString, Options);
set(handles.calculating, 'visible', 'off');
set(handles.figure1, 'pointer', prevPointer)
handles.field = field;
handles.doAnimate = false;
handles.imResizeFact = 2;
field = imresize(field, handles.imResizeFact, 'bilinear');
handles.resizedField = field;
handles.x = x;
handles.y = y;
set(handles.calc, 'enable', 'off')
guidata(hObject, handles);
update_axes(hObject, handles);

function update_axes(hObject, handles)
axes(handles.axes)
complexPartStringArray = get(handles.complexPart, 'string');
complexPartString = complexPartStringArray{get(handles.complexPart, 'value')};
field = handles.resizedField;
x = handles.x;
y = handles.y;
switch lower(complexPartString)
    case 'real'
        valToShow = real(field);
    case 'imag'
        valToShow = imag(field);
    case 'abs'
        valToShow = imresize(abs(handles.field), handles.imResizeFact, 'bilinear');
    case 'angle'
        valToShow = angle(field);
end
if handles.doAnimate
    nFrames = 80;
    t = linspace(0, 4*pi, nFrames);
else
    nFrames = 1;
end
M = max(abs(field(:)));
for iT = 1:nFrames
    if handles.doAnimate
        valToShow = real(field*exp(j*t(iT)));
        valToShow(1,1) = M;
        valToShow(end,end) = -M;
    end
    imagesc(x, y, valToShow);
    set(gca, 'ydir', 'normal');
    axis image
    line([min(x), max(x)], [0 0])
    hold on
    plot(handles.x0, handles.y0, 'wo')
    plot(handles.x0, handles.y0, 'w.')
    hold off
    drawnow
end
handles.doAnimate = false;
guidata(hObject, handles);
set(handles.animate, 'enable', 'on')

% --- If Enable == 'on', executes on mouse press in 5 pixel border.
% --- Otherwise, executes on mouse press in 5 pixel border or over els.
function els_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to els (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --- Executes on mouse press over figure background, over a disabled or
% --- inactive control, or over an axes background.
function figure1_WindowButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if strcmpi(get(hObject, 'pointer'), 'crosshair')
    mousePosition = get(handles.axes, 'CurrentPoint');
    handles.x0 = mousePosition(1,1);
    handles.y0 = mousePosition(1,2);
    guidata(hObject, handles);
    calc_Callback(hObject, eventdata, handles);
end


