% input is a number of arguments, some of which may be scalar and some of
% which may be matrices of the same size. replicates the scalars to the
% size of the matrices.
function varargout = rep_args(varargin)
rows = 1;
cols = 1;
bvRep = false(1,nargin);
for iArg = 1:nargin
    if numel(varargin{iArg})>1
        [rows, cols] = size(varargin{iArg});
        bvRep(iArg) = false;
    else
        bvRep(iArg) = true;
    end
end
if rows+cols == 2
    [varargout{1:nargin}] = varargin{1:nargin};
    return
end
varargout = cell(1,nargin);
for iArg = 1:nargin
    if bvRep(iArg)
        mArg = repmat(varargin{iArg},rows, cols);
        varargout(iArg) = {mArg};
    else
        varargout(iArg) = {varargin{iArg}};
    end
end
