function field = slowly_varying_no_beta(oPath, vX, vY, x_s, k0, Er_d, Er_u, sComp, bMSource)
global ETA
mKx = oPath.kx;
mKy_inc = oPath.ky_d;
mKy_t = oPath.ky_u;

vX = vX(:);
vY = vY(:);
nXY = length(vX);
[rows, cols] = size(mKx);
nKx = cols;
comp = comp_num(sComp);
k_u = k0*sqrt(Er_u);
k_d = k0*sqrt(Er_d);
ETA_d = ETA/sqrt(Er_d);
ETA_u = ETA/sqrt(Er_u);

mX = repmat(vX, 1, nKx);
mSx = sign(mX-x_s);

% return regularized integrand for calc_residue if on pole
k_pole = sqrt((Er_d*Er_u)/(Er_d+Er_u))*k0;
bmOnPoleSheet = sign(real(mKy_t).*real(mKy_inc))<0;
bmOnPole = bMSource & (mKx == k_pole) & bmOnPoleSheet;
R_para = zeros(size(mKx));
T_para = R_para;
if any(bmOnPole)
    R_para(bmOnPole) = (Er_u*mKy_inc(bmOnPole)-Er_d*mKy_t(bmOnPole)).^2./(2*k_pole)./(Er_d^2-Er_u^2);
    T_para(bmOnPole) = 2*Er_u*mKy_inc(bmOnPole).*(Er_u*mKy_inc(bmOnPole)-Er_d*mKy_t(bmOnPole))./(2*k_pole)./(Er_d^2-Er_u^2);
end
if any(~bmOnPole)
    T_para(~bmOnPole) = 2*Er_u*mKy_inc(~bmOnPole)./(Er_u*mKy_inc(~bmOnPole)+Er_d*mKy_t(~bmOnPole));
    R_para(~bmOnPole) = T_para(~bmOnPole)-1;
end
T_perp = 2*mKy_inc./(mKy_inc+mKy_t);
R_perp = T_perp-1;

mK_inc_x = mSx.*mKx;
mK_inc_y = mKy_inc;

mK_r_x = mK_inc_x;
mK_r_y = -mK_inc_y;
mK_t_x = mK_inc_x;
mK_t_y = mKy_t;
if ~bMSource
    aE0 = -1/4/pi/k_d*ETA_d*k_d^2./mKy_inc;
    aH0 = zeros(size(mKx));
else
    aH0 = -1/4/pi/k_d/ETA_d*k_d^2./mKy_inc;
    aE0 = zeros(size(mKx));
end

E_perp_i = aE0; %dot product
H_perp_i = aH0;

E_perp_r = R_perp.*E_perp_i;
E_perp_t = T_perp.*E_perp_i;
H_perp_r = R_para.*H_perp_i;
H_perp_t = T_para.*H_perp_i;

bRef = vY<=0;
mRef = repmat(bRef, 1, nKx);

ft1 = zeros(nXY, nKx);
fr1 = ft1;
field = ft1;
cross_t = cross_withZ(mK_t_x, mK_t_y, comp)/k_u;
cross_r = cross_withZ(mK_r_x, mK_r_y, comp)/k_d;

if lower(sComp(1)) == 'e'
    ft1(~mRef) = (E_perp_t(~mRef) - ...
        ETA_u*H_perp_t(~mRef).*cross_t(~mRef));
else
    ft1(~mRef) = (H_perp_t(~mRef) + ...
        1/ETA_u*E_perp_t(~mRef).*cross_t(~mRef));
end
field(~mRef) = ft1(~mRef);

if lower(sComp(1)) == 'e'
    fr1(mRef) = (E_perp_r(mRef) - ...
        ETA_d*H_perp_r(mRef).*cross_r(mRef));
else
    fr1(mRef) = (H_perp_r(mRef) + ...
        1/ETA_d*E_perp_r(mRef).*cross_r(mRef));
end

field(mRef) = fr1(mRef);

field = reshape(field, rows, cols);
    function out = cross_withZ(x, y, comp)
        switch comp
            case 1
                out = y;
            case 2
                out = -x;
            case 3
                out = zeros(size(x));
        end
    end
end